#!/bin/env fish
function chooseDisk -a result message
    set -l disks

    lsblk -do NAME,SIZE,TYPE | while read disk
        set -l diskInfo (string split -n " " $disk)

        if contains "$diskInfo[3]" "TYPE" "disk"
            set -a disks "$diskInfo"
        end
    end

    set -l diskCount (count $disks)
    set -l padding (math (string length "$diskCount") + 1)

    if [ "$diskCount" -gt 0 ]
        while true
            echo "$message"
            set -l prefix

            for i in (seq "$diskCount")
                if [ "$i" -eq 1 ]
                    set prefix ""
                else
                    set prefix "$(math "$i" - 1):"
                end

                printf "%"$padding"s %s\n" "$prefix" "$disks[$i]"
            end

            read -lP "Your choice: " choice

            if [ "$choice" -ge 1 ] && [ "$choice" -le "$diskCount" ]
                set -l disk (string split -n " " "$disks[$(math "$choice" + 1)]")
                set -g "$result" "/dev/$disk[1]"
                return
            else
                echo "The specified choise \"$choice\" is invalid!" >&2
            end
        end
    else
        echo "No valid disk found!" >&2
    end
end
